// Hauptprogramm
// RC5 Sender mit PIC12C508
// Sendet drei verschiedene Codes
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

#include "rc5send.h" //Pindefinitionen
#include "protos.h"

#include "phasemod.c"

//Globale Flags und Rckgabevariablen

unsigned char tastbuf;  //Tastaturpuffer fr lesen im INT
unsigned char toggle;   //Togglebit
unsigned char togglemask; //Merkt sich die Togglbits der Tasten
unsigned char comcode;  //Kommandocode

void main(void)
{ 
 unsigned char buf;

 OSCCAL=W; //Als erstes den Kalibrierwert fr den int. RC-Oszi sichern

 CLRWDT;         //Laut Datenblatt vor ndern Prescaler fr TMR0

 OPTION=0b00000111; //Wake up on pin change, weak pullups, Timer0 int. Source

 //Ein TimerClock = 1us * 256 = 256us
 //TMR0 luft ber alle 256 * 256us = 66ms
 //Wird aber nicht benutzt
 
//Nur GP0,1,3 knnen WakeUp machen und haben Pullups. Damit kommen nur
//sie als Eingnge fr die Taster in Frage
//An GP2 kommt die Sende-LED

 TRIS=0b111011; 	//0=Ausgang, 1=Eingang

 GPIO=0b111011;  //Port einmal schreiben

 if(GPWUF==0) { togglemask=0; toggle=0; } //Beim ersten einschalten Togglebits lschen

 while(1) // Anfang Programm Endlosschleife
  {
   tastbuf=~GPIO; //Tasten lesen, lowaktiv !!
   tastbuf&=0x0B; //nur die Pins Gp0,1,3 gltig
   
//Tastatur auswerten und Kommandocode setzen
   switch(tastbuf)
    {
     case KEY7: comcode=7;     break;
     case KEY6: comcode=6;     break;
     case KEY5: comcode=5;     break;
     default:   comcode=0;     break; //Ungltiger Kommandocode
    }   

    
   //Zur Sicherheit nur bei gltigen Kommandos weitermachen
   if(comcode>4) //Knnte man auch weglassen
    {

     //Togglebit der Taste merken bzw. verndern

     buf=0x01<<comcode; //Togglebit auf richtige Position schieben
//Diese if() Konstruktion mu weg damit
//der Sender wie eine richtige Fernbedienung arbeitet
     if(togglemask&buf) //Gesetzt ?
      {
       togglemask&=~buf; //Dann lschen
       toggle=0;         //Neues Togglebit
      }
     else //War nicht gesetzt
      {
       togglemask|=buf; //Dann setzen
       toggle=1;        //Neues Togglebit
      }

//Das hier aktivieren damit toggle wie bei einer normalen Fernbedienung arbeitet !
//     toggle=~toggle;
      
     PhaseMod(); //Codes 5x phasenmoduliert senden
     TMR0=0; while(TMR0<200); //50ms Totzeit
     PhaseMod(); 
     TMR0=0; while(TMR0<200); //50ms Totzeit
     PhaseMod(); 
     TMR0=0; while(TMR0<200); //50ms Totzeit
     PhaseMod(); 
     TMR0=0; while(TMR0<200); //50ms Totzeit
     PhaseMod(); 
     TMR0=0; while(TMR0<200); //50ms Totzeit

    }//if comcode
    
   tastbuf=GPIO; //Laut Datenblatt soll man das machen
   SLEEP;      //Wenn alles getan ist schlafen bis Taste gedrckt wird
                 //Bei WakeUp gibt es einen Reset !
                 
  } // Ende Programm Endlosschleife
}

